Package: org.codehaus.groovy.classgen.asm.sc

## [Java] Class StaticTypesUnaryExpressionHelper

- org.codehaus.groovy.classgen.asm.sc.StaticTypesUnaryExpressionHelper

-     public class StaticTypesUnaryExpressionHelper
      extends UnaryExpressionHelper

  An expression helper which generates optimized bytecode depending on the current type on top of the operand stack.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class UnaryExpressionHelper` | `controller`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `StaticTypesUnaryExpressionHelper(WriterController controller)` Creates a unary-expression helper that emits primitive-specialized bytecode when possible.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `writeBitwiseNegate(BitwiseNegationExpression expression)` * Generates bytecode for a bitwise negation expression. * * Parameters: `expression` - the bitwise negation expression
    `` | `public void` | `writeNotExpression(NotExpression expression)` * Generates bytecode for a logical not expression. * * Parameters: `expression` - the not expression
    `` | `public void` | `writeUnaryMinus(UnaryMinusExpression expression)` * Generates bytecode for a unary minus expression. * * Parameters: `expression` - the unary minus expression
    `` | `public void` | `writeUnaryPlus(UnaryPlusExpression expression)` * Generates bytecode for a unary plus expression. * * Parameters: `expression` - the unary plus expression

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class UnaryExpressionHelper` | `writeBitwiseNegate, writeNotExpression, writeUnaryMinus, writeUnaryPlus`

- - ### Constructor Detail

    - #### public StaticTypesUnaryExpressionHelper(WriterController controller)

      Creates a unary-expression helper that emits primitive-specialized bytecode when possible.

  - ### Method Detail

    - #### public void writeBitwiseNegate(BitwiseNegationExpression expression)

      * Generates bytecode for a bitwise negation expression. * *

      Parameters:
        `expression` - the bitwise negation expression

    - #### public void writeNotExpression(NotExpression expression)

      * Generates bytecode for a logical not expression. * *

      Parameters:
        `expression` - the not expression

    - #### public void writeUnaryMinus(UnaryMinusExpression expression)

      * Generates bytecode for a unary minus expression. * *

      Parameters:
        `expression` - the unary minus expression

    - #### public void writeUnaryPlus(UnaryPlusExpression expression)

      * Generates bytecode for a unary plus expression. * *

      Parameters:
        `expression` - the unary plus expression